<script lang="ts">
import Vue from 'vue';
import { getPageMetadata } from '../../common/meta';
import { NextStep } from '../../components/common/index.vue';
import {
  Conduct,
  EventSection,
  Intro,
  LightningHero,
  SpeakerSession,
} from '../../components/events/index.vue';
import { CONTENT_TYPES } from '../../common/content-types';
import { getClient } from '~/plugins/contentful.js';
import {
  StandardEventData,
  standardEventsDataHelper,
} from '~/services/events/events.service';
import { FooterEditLinkMixin } from '~/mixins';

export default Vue.extend({
  components: {
    NextStep,
    Conduct,
    LightningHero,
    SpeakerSession,
    Intro,
    EventSection,
  },
  mixins: [FooterEditLinkMixin],

  nuxtI18n: false,
  async asyncData() {
    try {
      const client = getClient();
      const query = await client.getEntries({
        content_type: CONTENT_TYPES.EVENT,
        include: 10,
        'sys.id': '55ut4OpTH7osA3cANGm6wm',
      });

      const entryFields = query.items[0]?.fields;
      const spaceId = query.items[0].sys.space.sys.id;
      const entryId = query.items[0].sys.id;
      const content: StandardEventData = standardEventsDataHelper(entryFields);

      return { content, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  head() {
    return getPageMetadata((this as any).content.metadata, this.$route.path);
  },
});
</script>

<template>
  <div>
    <LightningHero
      v-if="content.hero"
      :data="content.hero"
      :dark-mode="true"
      centered
    />
    <Intro v-if="content.description" :data="content.description" />
    <div v-if="content.booth">
      <EventSection
        v-for="(item, index) in content.booth"
        :key="index"
        :reverse="index % 2 !== 0"
        :data="item"
      />
    </div>
    <div v-if="content.sessions">
      <SpeakerSession
        v-for="(session, sessionIndex) in content.sessions"
        :key="sessionIndex"
        :data="session"
      />
    </div>
    <div v-if="content.footnote">
      <Conduct
        v-for="footnote in content.footnote"
        :key="footnote.header"
        :data="footnote"
      />
    </div>
    <NextStep :variant="content.nextSteps" />
  </div>
</template>
